/*  $Id: types.h,v 1.1 1998/02/11 04:28:04 shaggy Exp $
 *      relative path: ./lib/m-vax
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        (m-vax)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@mail.csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: types.h,v $
 *  Revision 1.1  1998/02/11 04:28:04  shaggy
 *  .
 *
 *  Revision 1.1  1998/02/10 00:18:36  shaggy
 *  .
 *
 *  Revision 1.1  1996/12/08  18:06:19  shaggy
 *  Initial revision
 *
 *      creation date: Fri May 17 12:53:58 1996
 */


#ifndef ASM

#include <inttypes.h>


typedef int32 		ofs_t;	// offsets into files

typedef uint32		vaddr_t;	/* virtual addresses (32) */
typedef int32		svaddr_t;	/* signed virtual addresses (32) */
typedef uint32		paddr_t;	/* physical addresses (32) */

/* for these page number types, 8 bits limits to 1Mb (for small machines)
 *				16 bits limits to 256Mb (most machines)
 *				32 bits limits to 16Tb (excessive)
 */
typedef uint16		vpage_t;	/* virtual page numbers (16/32) */
typedef uint16		ppage_t;	/* physical page numbers (8/16/32) */

typedef uint16		ref_t;		/* 64K max references */


#endif

