/*  $Id: assert.h,v 1.5 1998/05/26 16:40:51 shaggy Exp $
 *      relative path: ./lib/posix
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@mail.csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: assert.h,v $
 *  Revision 1.5  1998/05/26 16:40:51  shaggy
 *  fixed and cleaned up config
 *
 *  Revision 1.4  1997/06/21 12:24:18  shaggy
 *  header update
 *
 *  Revision 1.3  1997/01/18 22:49:06  shaggy
 *  header update
 *
 *  Revision 1.2  1996/12/20 18:11:56  shaggy
 *  simplified (assert_range removed)
 *
 *  Revision 1.1  1996/11/29  19:00:44  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */


#include <posix/posix.h>

#undef assert

#ifdef NDEBUG
#define assert(exp) ((void) 0)
#else 

#define assert(c)       ((void)((c) || (assertfail(c), 0)))

#ifndef assertfail
#	define assertfail(c) _assertfail(#c, __FILE__, __LINE__)
	void _assertfail(const char *c, const char *fname, int line);
#endif

#endif

