/*  $Id: fcntl.h,v 1.2 1997/06/21 12:23:59 shaggy Exp $
 *      relative path: ./lib/posix
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@mail.csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*
 *  $Log: fcntl.h,v $
 *  Revision 1.2  1997/06/21 12:23:59  shaggy
 *  header update
 *
 *  Revision 1.1  1997/01/21 05:04:01  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */


#include <posix/posix.h>
#include <posix/sys/types.h>

#define O_ACCMODE	0x03
#define O_RDONLY	0x00
#define O_WRONLY	0x01
#define	O_RDWR		0x02
#define	O_CREAT		0x04
#define O_TRUNC		0x08
#define O_APPEND	0x10	
#define O_EXCL		0x20
#define O_NOCTTY	0x40
#define O_NONBLOCK	0x80

#define FD_CLOEXEC	XXX
#define F_DUPFD		XXX
#define F_GETFD		XXX
#define F_GETFL		XXX
#define F_GETLK		XXX
#define F_RDLCK		XXX
#define F_SETFD		XXX
#define F_SETFL		XXX
#define F_SETLK		XXX
#define F_SETLKW	XXX
#define F_UNLCK		XXX
#define F_WRLCK		XXX

#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2


struct flock {
	short	l_type;
	short	l_whence;
	off_t	l_start;
	off_t	l_len;
	pid_t	l_pid;
};


/*
extern_C obj_t open(char *path, int oflag, ...);
extern_C obj_t creat(char *path, int mode);
extern_C status_t close(obj_t fd);
extern_C off_t lseek(obj_t fd, off_t offset, int whence);
extern_C obj_t dup(obj_t fd);
extern_C obj_t dup2(obj_t fd, obj_t fd2);
extern_C obj_t fcntl(obj_t fd, int cmd, ...);
*/

