/*  $Id: stdarg.h,v 1.7 1998/07/06 04:43:06 shaggy Exp $
 *      relative path: ./lib/posix
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@mail.csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: stdarg.h,v $
 *  Revision 1.7  1998/07/06 04:43:06  shaggy
 *  fixed to keep new gcc from complaining about lvalues
 *
 *  Revision 1.6  1998/06/04 02:28:10  shaggy
 *  various config updates
 *
 *  Revision 1.5  1998/04/23 20:11:40  shaggy
 *  more changes for Solaris
 *
 *  Revision 1.4  1997/06/21 12:24:16  shaggy
 *  header update
 *
 *  Revision 1.3  1997/01/18 22:49:04  shaggy
 *  header update
 *
 *  Revision 1.2  1996/11/29 22:04:53  shaggy
 *  fixed incrementation order
 *
 *  Revision 1.1  1996/11/29  21:35:19  shaggy
 *  Initial revision
 *
 *      creation date: 1992
 */


#include <posix/posix.h>
#include <posix/sys/types.h>

#ifndef _VA_LIST
#define _VA_LIST

/* XXX - this is a very unclean and not very portable way of
 * handling this, which needs to be cleaned up when there's time
 */

#ifdef ARCH_sparc

typedef void *__gnuc_va_list;
 
typedef __gnuc_va_list va_list;

#ifndef va_start 
#define va_start(AP, LASTARG) \
  (__builtin_next_arg (LASTARG), AP = (char *) __builtin_saveregs ())
#define va_end(ap)
/* this is not entirely correct, but hey, for now it seems to work: */
#define va_arg(ap,type)		__extension__((sizeof(type)<sizeof(uint)) \
		? *((type*)( ((uint*)ap)++ ))  \
		: *(((type*)ap)++) )
#endif
 
#else

typedef void *va_list;

#ifndef va_start
#define va_start(ap,arg)	(ap)=((va_list)(&(arg)+1));
#define va_end(ap)
#define va_arg(ap,type)		__extension__((sizeof(type)<sizeof(uint)) \
		? *((type*)( (*(uint**)ap)++ ))  \
		: *((*(type**)ap)++) )
#endif
#endif

#endif

