/*  $Id: types.h,v 1.2 1998/02/11 04:52:41 shaggy Exp $
 *      standard data type definitions
 *      relative path: ./lib/posix/sys
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-compliant code
 *         System specific
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@mail.csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: types.h,v $
 *  Revision 1.2  1998/02/11 04:52:41  shaggy
 *  using uint16, etc
 *
 *      creation date: 1992
 */

#include <posix/posix.h>
#include <types.h>
/* types.h has declarations for:
 *	time_t
 *	ptrdiff_t
 *	size_t
 */

typedef uint16		dev_t;
typedef uint32		ino_t;
typedef uint16		mode_t;
typedef uint16		nlink_t;
typedef int32		off_t;
typedef uint32		pid_t;
typedef uint16		uid_t;
typedef uint16		gid_t;

typedef	time_t		clock_t;

#ifndef _SSIZE_T
#define _SSIZE_T
typedef uintptr		ssize_t;
#endif

