/*  $Id: ccout.cc,v 1.79 1998/07/12 19:01:24 shaggy Exp $
 *      C++ output
 *      
 *      relative path: ./lib/cparse
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        C/C++ Parsing classes
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@mail.csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

//  $Log: ccout.cc,v $
//  Revision 1.79  1998/07/12 19:01:24  shaggy
//  many more cvqual fixes
//
//  Revision 1.78  1998/07/12 03:58:47  shaggy
//  lots of const fixes, -frealtype option, -dT option; better debugging
//
//  Revision 1.77  1998/07/11 23:06:50  shaggy
//  fixed labels and goto
//
//  Revision 1.76  1998/07/11 19:03:01  shaggy
//  declarations in for() work now (even multiple decls)
//
//  Revision 1.75  1998/07/10 13:45:09  shaggy
//  working on decls in conditions
//
//  Revision 1.74  1998/07/09 04:53:28  shaggy
//  more fn matching fixes
//
//  Revision 1.73  1998/07/08 21:45:03  shaggy
//  lots of enhancements for function call matching
//
//  Revision 1.72  1998/07/08 13:42:43  shaggy
//  started adding proper function calls
//
//  Revision 1.71  1998/07/07 13:41:41  shaggy
//  enum cleanup, and can define types inside functions now
//
//  Revision 1.70  1998/07/07 02:51:14  shaggy
//  more fixes for declaration ordering
//
//  Revision 1.69  1998/07/06 22:49:43  shaggy
//  reworked symtab, output ordering, etc
//
//  Revision 1.68  1998/07/06 15:07:51  shaggy
//  more config fixes
//
//  Revision 1.67  1998/07/06 13:39:07  shaggy
//  many more changes/fixes for first pre-release
//
//  Revision 1.66  1998/07/05 20:32:57  shaggy
//  tons of bugfixes, enhancements and parser improvements
//
//  Revision 1.65  1998/07/05 02:47:38  shaggy
//  tons of bug fixes
//
//  Revision 1.64  1998/07/04 20:39:00  shaggy
//  lots of bug fixes; fn, aggr, etc improvements, new/delete
//
//  Revision 1.63  1998/07/04 01:23:30  shaggy
//  anonymous unions work now
//
//  Revision 1.62  1998/07/03 16:53:52  shaggy
//  new Scope wrapper class, and dcast_XXX functions eliminate lots of casts
//
//  Revision 1.61  1998/07/02 13:25:52  shaggy
//  public/private/protected works for inheritance
//
//  Revision 1.60  1998/06/30 15:38:38  shaggy
//  better support for member fns and member fn ptrs
//
//  Revision 1.59  1998/06/29 14:14:17  shaggy
//  more DECO conversions, support for 'this', etc
//
//  Revision 1.58  1998/06/29 01:36:55  shaggy
//  fixed inline attr, output of pure virtuals, etc...
//
//  Revision 1.57  1998/06/07 18:09:04  shaggy
//  added types to Expr()'s, and fixed output of members (. and ->)
//
//  Revision 1.56  1998/06/07 15:45:12  shaggy
//  realtype() works, and . and -> now work
//
//  Revision 1.55  1998/06/07 02:33:40  shaggy
//  uses hex for digits > 9
//
//  Revision 1.54  1998/06/02 14:50:42  shaggy
//  in the midst of more full parsing updates
//
//  Revision 1.53  1998/06/01 02:10:35  shaggy
//  more code parsing working
//
//  Revision 1.52  1998/05/31 21:08:03  shaggy
//  fixed output scoping
//
//  Revision 1.51  1998/05/26 21:34:16  shaggy
//  C/C++/DC++ header formats now supported
//  header output includes external requirements
//
//  Revision 1.50  1998/05/26 13:40:14  shaggy
//  many more fixes
//
//  Revision 1.49  1998/05/26 05:02:55  shaggy
//  parameter scoping works correctly
//  most basic C/C++ statements now work
//
//  Revision 1.48  1998/05/25 23:28:45  shaggy
//  major rework of func/param info
//
//  Revision 1.47  1998/05/25 20:08:41  shaggy
//  more bugfixes
//
//  Revision 1.46  1998/05/25 04:22:14  shaggy
//  enough for tonight
//
//  Revision 1.45  1998/05/24 23:39:33  shaggy
//  various bug fixes and code cleanup
//
//  Revision 1.44  1998/05/24 18:42:00  shaggy
//  improved regression testing
//  proper scoping for initializers
//  decls available for their initializer
//
//  Revision 1.43  1998/05/24 01:41:42  shaggy
//  internal support for most statements
//
//  Revision 1.42  1998/05/22 14:42:39  shaggy
//  fixed output formatting
//
//  Revision 1.41  1998/05/21 13:27:21  shaggy
//  output formatting problems
//
//  Revision 1.40  1998/05/20 14:41:24  shaggy
//  better code output
//
//  Revision 1.39  1998/05/19 14:55:36  shaggy
//  a bit closer to generating code (stmtlists work)
//
//  Revision 1.38  1998/05/18 05:24:28  shaggy
//  more cleanup of declaration support functions
//
//  Revision 1.37  1998/05/17 23:14:57  shaggy
//  expressions, expression lists, etc
//
//  Revision 1.36  1998/05/16 23:30:44  shaggy
//  added CTOR_ID and some rules to help fix ctor ambiguity problem
//  output turned off for #include'ed files
//  better error checking, and ability to list locations
//  of symbol declaration and definition
//
//  Revision 1.35  1998/05/15 07:03:37  shaggy
//  dependency ordering fixed; constructor initializers; lots of bug fixes, etc
//
//  Revision 1.34  1998/05/15 00:17:27  shaggy
//  ctor initializers work, and enums are fixed so declarations
//  in an enum can be immediately re-used
//
//  Revision 1.33  1998/05/14 18:02:05  shaggy
//  fixed constant handling, enums, function cv tags, etc
//
//  Revision 1.32  1998/05/14 05:08:42  shaggy
//  inheritence works and lots of bugs fixed
//
//  Revision 1.31  1998/05/13 21:39:36  shaggy
//  switched to dtype/ptype/rtype
//
//  Revision 1.30  1998/05/13 21:02:48  shaggy
//  deinitions/initializations work better now
//
//  Revision 1.29  1998/05/12 22:40:24  shaggy
//  scoping FINALLY works right (or seems to)
//
//  Revision 1.28  1998/05/12 20:14:09  shaggy
//  scoping works except for output with nested dependencies
//
//  Revision 1.27  1998/05/12 15:53:21  shaggy
//  scoping and class tags almost work
//
//  Revision 1.26  1998/05/12 05:00:14  shaggy
//  more scope work
//
//  Revision 1.25  1998/05/08 13:03:24  shaggy
//  fixed const/volatile
//
//  Revision 1.24  1998/05/07 14:46:40  shaggy
//  const/volatile partially working
//
//  Revision 1.23  1998/05/04 04:39:50  shaggy
//  first stage of function overloading
//
//  Revision 1.22  1998/05/04 03:09:21  shaggy
//  support for ctors, dtors, conversion operators, operator overloading, etc
//
//  Revision 1.21  1998/05/03 17:07:30  shaggy
//  more improvements to make internal declarations easier
//
//  Revision 1.20  1998/05/03 02:47:08  shaggy
//  added inheritence to parser
//
//  Revision 1.19  1998/04/27 04:36:48  shaggy
//  started auto-generation of code
//
//  Revision 1.18  1998/04/26 14:58:52  shaggy
//  fixed to output standard C++ types (instead of int32,etc)
//
//  Revision 1.17  1998/04/23 20:11:41  shaggy
//  more changes for Solaris
//
//  Revision 1.16  1998/04/22 13:06:39  shaggy
//  better enum handling
//
//  Revision 1.15  1998/04/22 12:17:51  shaggy
//  changed ID to Id for consistency
//
//  Revision 1.14  1998/04/17 18:02:03  shaggy
//  more stuff to make it build under Solaris
//
//  Revision 1.13  1998/04/17 04:37:41  shaggy
//  public/privat/protected works now
//
//  Revision 1.12  1998/04/16 13:35:33  shaggy
//  access control
//
//  Revision 1.11  1998/04/15 14:47:58  shaggy
//  array output works
//
//  Revision 1.10  1998/04/15 13:39:56  shaggy
//  added types to constants
//
//  Revision 1.9  1998/04/14 13:18:58  shaggy
//  fixed stuff
//
//  Revision 1.8  1998/04/13 01:30:23  shaggy
//  even better C++ output
//
//  Revision 1.7  1998/04/12 18:38:07  shaggy
//  improved code output
//
//  Revision 1.6  1998/04/12 03:19:34  shaggy
//  got function output working
//
//  Revision 1.5  1998/04/11 21:48:42  shaggy
//  added some simple regurgitation
//
//  Revision 1.4  1998/04/07 13:38:19  shaggy
//  fixed up enums some more
//
//  Revision 1.3  1998/04/06 14:27:43  shaggy
//  lots more changes, and added some tests
//
//  Revision 1.2  1998/02/09 00:06:54  shaggy
//  proper C++ output
//
//  Revision 1.1  1998/02/08 23:41:58  shaggy
//  Initial revision
//

// #pragma Make Config_Needed += local
#pragma Make Includes_Banned += -nostdinc -nostdinc++
#pragma Make Flags_Banned += -static

#define USE_STDLIB
#include <sys/types.h>
#include <defines>
#include <unistd.h>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <fcntl.h>

#include <CObj>
#include <CLex>
#include <CParse>
#include <CAction>
#include <TokenList>	// perhaps should be part of CAction
#include <StrTab>
#include <SymTab>

#include <posix/assert.h>

#include "ccint.h"
#include "ccout.h"

#define T(x)	CAction::x


#define INTERNAL_ERROR	{ _err.internal_error(__FILE__, __LINE__, __FUNCTION__); \
			  for(;;) ; }

typedef vStrTab::Id Id;

sz *
strpcat(sz *str, csz *prefix)
{
	size_t n = strlen(prefix);
	memmove(str+n, str, strlen(str)+1);
	memcpy(str, prefix, n);
	return str;
}


struct objtn { obj_Integral *o; csz *n; } itypes[] = {
	{&Type_char, "char"},
	{&Type_schar, "signed char"},
	{&Type_uchar, "unsigned char"},
	{&Type_int, "int"},
	{&Type_uint, "unsigned int"},
	{&Type_short, "short"},
	{&Type_ushort, "unsigned short"},
	{&Type_long, "long"},
	{&Type_ulong, "unsigned long"},
	{&Type_long2, "long long"},
	{&Type_ulong2, "unsigned long long"},
	{0, 0},
};


csz*
simple_typename(const type_t type)
{
	for(objtn *ip = itypes; ip->n; ip++) {
		if(ip->o == type)
			return ip->n;
	}
	return "?";
}

void
CCOut::_assertfail(csz *cond, csz *file, int line)
{
	char buf[MAXIDLEN];

	onl();
	_err.error("Assertion \"%s\" failed (%s:%d)", cond, file, line);
	_err.error("Failed for %s", scoped_string(_curdecl, buf, true));
	_err.internal_error(file, line, 0);
}

sz *
CCOut::literal_string(const type_t type, uint64 val, sz *s)
{
	char *saveobuf = _obuf;
	_obuf = s;
	printliteral(type, val);
	_obuf = saveobuf;
	return s;
}


sz *
CCOut::dbg_type_string(const type_t type, sz *s)
{
	assert(s);

	if(!type)
		strcat(s, "<null>");
	else if(Method *meth = dcast_Method(type)) {
		strcat(s, "Method(");
		s = dbg_type_string(meth->otype(), s);
		strcat(s, ",");
		s = dbg_type_string(meth->ftype(), s);
		strcat(s, ")");
	} else if(Func *func = dcast_Func(type)) {
		strcat(s, "Func(");
		if(func->scope())
			scoped_string(func->scope(), s+strlen(s));
		else
			strcat(s, "<null>");
		strcat(s, ", ");
		dbg_type_string(func->rtype(), s);
		strcat(s, ", ");
		dbg_type_string(func->psig(), s);
	} else if(Params *par = dcast_Params(type)) {
		strcat(s, "Params(");
		for(uint i=0; i<par->nparam(); i++) {
			if(i)
				strcat(s, ", ");
			s = dbg_type_string(par->ptype(i), s);
		}
		if(par->is_variable())
			strcat(s, "...");
		strcat(s, ")");
	} else if(Array *array = dcast_Array(type)) {
		sprintf(s+strlen(s), "Array(%d, ", array->size());
		s = dbg_type_string(array->rtype(), s);
		strcat(s, ")");
	} else if(PtrTo *ptr = dcast_PtrTo(type)) {
		strcat(s, "PtrTo(");
		if(ptr->is_volatile()) strcat(s, "v, ");
		if(ptr->is_const()) strcat(s, "c, ");
		s = dbg_type_string(ptr->rtype(), s);
		strcat(s, ")");
	} else if(RefTo *ref = dcast_RefTo(type)) {
		strcat(s, "RefTo(");
		if(ref->is_volatile()) strcat(s, "v, ");
		if(ref->is_const()) strcat(s, "c, ");
		s = dbg_type_string(ref->rtype(), s);
		strcat(s, ")");
	} else if(Qualifier *qual = dcast_Qualifier(type)) {
		strcat(s, "Qual(");
		if(qual->is_volatile()) strcat(s, "v, ");
		if(qual->is_const()) strcat(s, "c, ");
		s = dbg_type_string(qual->rtype(), s);
		strcat(s, ")");
	} else if(DeclRef *dref = dcast_DeclRef(type)) {
		strcat(s, "DeclRef(");
		scoped_string(dref->decl(), s+strlen(s));
		strcat(s, ")");
	} else if(Aggr *aggr = dcast_Aggr(type)) {
		strcat(s, "Aggr(");
		if(aggr->name())
			strcat(s, _strtab->string(aggr->name()));
		else
			strcat(s, "<null>");
		if(aggr->scope())
			sprintf(s+strlen(s), "%p", aggr->scope());
		strcat(s, ")");
	} else if(Enum *enm = dcast_Enum(type)) {
		strcat(s, "Enum(");
		scoped_string(enm->decl(), s+strlen(s));
		strcat(s, ")");
	} else if(Integral *integ = dcast_Integral(type)) {
		sprintf(s+strlen(s), "Integral(%d,%d,%c,%c)",
			integ->bitsize(), integ->alignment(),
			integ->is_signed() ? 's' : 'u',
			integ->is_big_endian() ? 'b' : 'l');
	} else if(type == &Type_bool)
		strcat(s, "bool");
	else if(type == &Type_wchar)
		strcat(s, "wchar_t");
	else if(type == &Type_float)
		strcat(s, "float");
	else if(type == &Type_double)
		strcat(s, "double");
	else if(type == &Type_void)
		strcat(s, "void");
	else if(type->is_null())
			strcat(s, "<null type>"); 
	else {
		sprintf(s+strlen(s), "<unknown:%p/%#llx>",
				type->type(), type->data());
	}
	return s;
}

sz *
CCOut::type_string(const type_t type, sz *s)
{
	assert(s);

	char buf[MAXTYPELEN];

	if(_debugtypes) {
		if(*s)
			strcat(s, ": ");
		return dbg_type_string(type, s);
	}
	if(!type)
		return s;
	if(Method *meth = dcast_Method(type)) {
		type_t otype = meth->otype();
		bool is_const = false;
		bool is_volatile = false;
		while(Qualifier *qual = dcast_Qualifier(otype)) {
			if(qual->is_const())
				is_const = true;
			if(qual->is_volatile())
				is_volatile = true;
			otype = qual->rtype();
		}
		if(s[0] == '*') {
			strpcat(s, "::");
			s = type_string(meth->otype(), s);
			strpcat(s, "(");
			strcat(s, ")");
		}
		s = type_string(meth->ftype(), s);
		if(is_const)
			strcat(s, " const");
		if(is_volatile)
			strcat(s, " volatile");
	} else if(Func *func = dcast_Func(type)) {
		if(s[0] == '*' || s[0] == '&') {
			strpcat(s, "(");
			strcat(s, ")");
		}
		strcat(s, "(");
		for(uint i=0; i<func->nparam(); i++) {
			if(i)
				strcat(s, ", ");
			Decl *d = param_decl(func, i);
			if(d && d->id)
				strcpy(buf,
				   _strtab->string(d->id));
			else 
				buf[0] = '\0';
			strcat(s, type_string(func->ptype(i),
						buf));
			if(d && d->initialized) {
				strcat(s, " = ");
				if(d->storage == TDecl::sc_constant)
					sprintf(s+strlen(s), "%lld", d->c.val);
				else {
					char *saveobuf = _obuf;	
					_obuf = s+strlen(s);
					printexpr(d->v.expr);
					_obuf = saveobuf;
				}
			}
		}
		if(func->is_variable()) {
			if(func->nparam())
				strcat(s, ", ");
			strcat(s, "...");
		}
		strcat(s, ")");
		s = type_string(func->rtype(), s);
	} else if(Params *par = dcast_Params(type)) {
		if(s[0] == '*' || s[0] == '&') {
			strpcat(s, "(");
			strcat(s, ")");
		}
		strcat(s, "(");
		for(uint i=0; i<par->nparam(); i++) {
			if(i)
				strcat(s, ", ");
			buf[0] = '\0';
			strcat(s, type_string(par->ptype(i),
						buf));
		}
		if(par->is_variable()) {
			if(par->nparam())
				strcat(s, ", ");
			strcat(s, "...");
		}
		strcat(s, ")");
	} else if(Array *array = dcast_Array(type)) {
		if(s[0] == '*' || s[0] == '&') {
			strpcat(s, "(");
			strcat(s, ")");
		}
		if(array->size() == NPOS)
			sprintf(buf, "[]");
		else if(0 == array->lower_bound()) 
			sprintf(buf, "[%d]", array->size());
		else
			sprintf(buf, "[%d..%d]", array->lower_bound(),
					array->upper_bound());
		strcat(s, buf);
		s = type_string(array->rtype(), s);
	} else if(PtrTo *ptr = dcast_PtrTo(type)) {
		if(ptr->is_volatile()) strpcat(s, "volatile ");
		if(ptr->is_const()) strpcat(s, "const ");
		strpcat(s, "*");
		s = type_string(ptr->rtype(), s);
	} else if(RefTo *ref = dcast_RefTo(type)) {
		if(ref->is_volatile()) strpcat(s, "volatile ");
		if(ref->is_const()) strpcat(s, "const ");
		strpcat(s, "&");
		s = type_string(ref->rtype(), s);
	} else if(Qualifier *qual = dcast_Qualifier(type)) {
		type_t rtype = qual->rtype();
		s = type_string(rtype, s);
		if(rtype->is_type(Type_Func)) {
			if(qual->is_volatile()) strcat(s, " volatile");
			if(qual->is_const()) strcat(s, " const");
		} else {
			if(qual->is_volatile()) strpcat(s, "volatile ");
			if(qual->is_const()) strpcat(s, "const ");
		}
	} else {
		if(*s) strpcat(s, " ");
		if(DeclRef *dref = dcast_DeclRef(type)) {
			char buf[MAXIDLEN];
			Decl *decl = dref->decl();
			strpcat(s, scoped_string(decl, buf));
		} else if(Aggr *aggr = dcast_Aggr(type)) {
			/* XXX - needs scope */
			if(aggr->name())
				strpcat(s, _strtab->string(aggr->name()));
			else if (aggr->scope()) {
				Decl *d = Scope(aggr->scope()).decl();
				strpcat(s, _strtab->string(d->id));
			} else {	
				sprintf(buf, "anonymous%lx", (uintptr)aggr->scope());
				strpcat(s, buf);
			}
		} else if(Enum *enm = dcast_Enum(type)) {
			char buf[MAXIDLEN];
			strpcat(s, scoped_string(enm->decl(), buf));
		} else if(type->is_type(Type_Integral)) 
			strpcat(s, simple_typename(type));
		else if(type == &Type_bool)
			strpcat(s, "bool");
		else if(type == &Type_wchar)
			strpcat(s, "wchar_t");
		else if(type == &Type_float)
			strpcat(s, "float");
		else if(type == &Type_double)
			strpcat(s, "double");
		else if(type == &Type_void)
			strpcat(s, "void");
		/* else if(type->is_null())
			strpcat(s, "<null>");  */
		else {
			sprintf(buf, "<unknown:%p/%#llx>",
				type->type(), type->data());
			strpcat(s, buf);
		}
	}
	return s;
}

/*
sz*
CCOut::fullscoped_string(Id id, Scope sc, sz *s)
{
	Scope parent = sc.parent();
	if(parent) {
		s = scoped_string(sc.pchid(), parent, s);
		strcat(s, "::");
	} else
		strcpy(s, "::");
	strcat(s, _strtab->string(id));
	return s;
}
*/


sz*
CCOut::scoped_string(Scope sc, sz *s)
{
	assert(sc);
	assert(s);

	Scope parent = sc.parent();
	if(sc == _scope) 
		*s = '\0';
	else if(!parent) 
		strcpy(s, "::");
	else {
		Decl *d = sc.decl();
		Scope st = 0;
		csz *sn;
		if(!d)
			sn = "{";
		else if(!d->id)
			sn = "?";
		else if(d->id == ID_ANON)
			sn = "<anon>";
		else {
			sn = _strtab->string(d->id);
			if(Decl *nd = symfind(d->id, _scope, true)) {
				type_t t = nd->ptype;
				if(Aggr *aggr = dcast_Aggr(t)) 
					st = aggr->scope();
			}
		}
		sz *sp = s;
		if(st != sc || _fullscope) 
			sp += strlen(scoped_string(parent, sp));
		strcpy(sp, sn);
		if(d && d->is_func() && !_debugtypes)
			type_string(d->rtype, sp);
		strcat(sp, "::");
	}
	return s;
}


static bool
canfind(Decl *decl, const Scope inscope, bool withtag)
{
	Decl *d;
	d = symfind(decl->id, inscope, withtag);
	while(d && d != decl && !d->odeclared && !inscope.pchid())
		d = d->link;
	if(!d && inscope.parent())
		return canfind(decl, inscope.parent(), withtag);
	return d == decl || (d && d->scope == decl->scope);
}

sz*
CCOut::scoped_string(Decl *decl, sz *s, bool needtag)
{
	assert(decl);
	assert(s);

	Scope sc = decl->scope;
	if(_fullscope) {
		needtag = true;
		scoped_string(sc, s);
	} else if(canfind(decl, _scope, false)) {
		*s = '\0';
	} else {
		if(decl->tagged() && canfind(decl, _scope, true)) {
			*s = '\0';
			needtag = true;
		} else {
			if(decl->tagged() && !canfind(decl, sc, false))
				needtag = true;
			scoped_string(sc, s);
		}
	}
	{
		csz *ss = _strtab->string(decl->id);
		while(*ss == ' ')
			++ss;
		strcat(s, ss);
	}
	if(needtag && decl->tagged()) {
		strpcat(s, " ");
		strpcat(s, TDecl::dtname[decl->dtype]);
	}
	return s;
}


void
CCOut::onl(int y)
{
	while(_nl < y) {
		if(_obuf) 
			strcat(_obuf, " ");
		else
			printf("\n");
		_x = 0;
		++_nl;
	}
}

void
CCOut::onltab(int x)
{
	onl();
	if(x < 0)
		x = _indent;
	if(x < _x) {
		if(!_obuf)
			printf("\n");
		++_nl;
		_x = 0;
	}
	if(x > _x && !_obuf)
		printf("%*s", x-_x, "");
	_x = x;
}

int
CCOut::oprintf(csz *fmt, ...)
{
	int n;
	if(!_obuf && _x == 0)
		onltab();
	va_list ap;
	va_start(ap, fmt);
	if(_obuf)
		n = vsprintf(_obuf+strlen(_obuf), fmt, ap);
	else
		n = vprintf(fmt, ap);
	va_end(ap);
	if(!_obuf && n > 0) {
		_nl = 0;
		_x += n;
	}
	return n;
}


void
CCOut::printliteral(const type_t type, uint64 val)
{
	assert(type);

	csz *fmt;
	bool use64 = false;
	if(type == &Type_int) 
		fmt = "%d";
	else if(type == &Type_uint)
		fmt = "%uU";
	else if(type == &Type_long)
		fmt = "%ldL";
	else if(type == &Type_ulong)
		fmt = "%luUL";
	else if(type == &Type_long2) {
		fmt = "%lldLL"; use64 = true;
	} else if(type == &Type_ulong2) {
		fmt = "%lluULL"; use64 = true;
	} else if(type == &Type_char) {
		char ch = val;
		oprintf("%s", _clex.token_string(CLex::CHAR, &ch, 1));
		return;
	} else if(type == &Type_bool) {
		oprintf(val ? "true" : "false");
		return;
	} else if(type == &Type_Str) {
		oprintf("%s", _clex.token_string(CLex::STR,
			_strtab->string((vStrTab::Id)val)));
		return;
	} else {
		char buf[MAXTYPELEN];
		buf[0] = '\0';
		if((int64)val >= -1 && (int64)val <= 1)
			fmt = "((%s)%lld)";
		else
			fmt = "((%s)0x%llx)";
		oprintf(fmt, type_string(type, buf), val);
		return;
	}
	if(use64)
		oprintf(fmt, val);
	else
		oprintf(fmt, (uint32)val);
}


void
CCOut::printexprlist(ExprList exprlist)
{
	for(Expr e = exprlist.first(); e; e++) {
		printexpr(e);
		if(e.next())
			oprintf(", ");
	}
}

void
CCOut::printstmtlist(StmtList stmtlist)
{
	const Scope savescope = _scope;
	if(!(_scope = stmtlist.scope()))
		_scope = savescope;
	oprintf("{");
	rshift();
	for(Stmt s = stmtlist.first(); s; s++) {
		onl();
		printstmt(s);
	}
	lshift();
	onl();
	oprintf("}");
	_scope = savescope;
}

void
CCOut::printdecllist(StmtList stmtlist)
{
	const Scope savescope = _scope;
	bool first = true;
	if(!(_scope = stmtlist.scope()))
		_scope = savescope;
	for(Stmt s = stmtlist.first(); s; s++) {
		assert(s.op() == T(DECL));
		Decl *d = s.left().decl();
		if(first)
			define_sym(d, false);
		else {
			oprintf(", %s = ", _strtab->string(d->id));
			printexpr(d->v.expr);	/* XXX - const? */
		}	
		d->odeclared = true;
		d->odefined = true;
		first = false;
	}
	_scope = savescope;
}

void
CCOut::printctorinit(StmtList stmtlist)
{
	if(stmtlist.empty())
		return;
	const Scope savescope = _scope;
	if(!(_scope = stmtlist.scope()))
		_scope = savescope;
	rshift();
	onltab(_indent-2);
	oprintf(": ");
	for(Stmt s = stmtlist.first(); s; ) {
		char buf[MAXIDLEN];
		assert(s.left().op() == T(VAL_ID));
		oprintf("%s", scoped_string(s.left().decl(), buf, false));
		oprintf("(");
		printexpr(s.right());
		oprintf(")");
		if(++s) {
			oprintf(",");
			onl();
		}
	}
	lshift();
	onl();
	_scope = savescope;
}

void
CCOut::printstmt(Stmt stmt)
{
	if(!stmt)
		return;
	switch(stmt.op()) {
	case T(KW_IF):
		oprintf("if");
		printexpr(stmt.left(), true);
		printstmti(Stmt(stmt.mid()));
		if(stmt.right()) {
			if(stmt.mid().op() == T(STMTLIST))
				oprintf(" ");
			else
				onl();
			oprintf("else");
			if(stmt.right().op() == T(KW_IF)) {
				oprintf(" ");
				printstmt(Stmt(stmt.right()));
			} else
				printstmti(Stmt(stmt.right()));
		}
		break;
	case T(KW_DO):
		oprintf("do");
		if(stmt.mid().op() != T(STMTLIST)) {
			oprintf(" ");
			printstmt(Stmt(stmt.mid()));
		} else
			printstmti(Stmt(stmt.mid()));
		oprintf(" while");
		printexpr(stmt.right(), true);
		oprintf(";");
		break;
	case T(KW_WHILE):
		oprintf("while");
		printexpr(stmt.left(), true);
		printstmti(Stmt(stmt.mid()));
		break;
	case T(KW_SWITCH):
		oprintf("switch");
		printexpr(stmt.left(), true);
		printstmti(Stmt(stmt.mid()));
		break;
	case T(KW_FOR): {
		const Scope savescope = _scope;
		Expr left = stmt.left();
		Expr forinit = left.left();
		Expr forcond = left.mid();
		if(forinit && forinit.op() == T(STMTLIST)) {
			StmtList stmtlist(forinit);
			if(!(_scope = stmtlist.scope()))
				_scope = savescope;
		} else if(forcond && forcond.op() == T(STMTLIST)) {
			StmtList stmtlist(forcond);
			if(!(_scope = stmtlist.scope()))
				_scope = savescope;
		}
		oprintf("for");
		printexpr(stmt.left(), true);
		printstmti(Stmt(stmt.mid()));
		_scope = savescope;
		} break;
	case T(KW_RETURN):
		oprintf("return ");
		printexpr(stmt.left());
		oprintf(";");
		break;
	case T(KW_GOTO):
		oprintf("goto ");
		printexpr(stmt.left());
		oprintf(";");
		break;
	case T(KW_BREAK):
		oprintf("break;");
		break;
	case T(KW_CONTINUE):
		oprintf("continue;");
		break;
	case T(KW_DEFAULT):
	case T(KW_CASE):
	case T(COLON):
		onltab(_indent-_tabwid+1);
		if(stmt.op() == T(KW_DEFAULT))
			oprintf("default:");
		else {
			if(stmt.op() == T(KW_CASE))
				oprintf("case ");
			printexpr(stmt.left());
			oprintf(":");
		}
		if(stmt.mid()) {
			onl();
			printstmt(Stmt(stmt.mid()));
		}
		break;
	case T(KW_ASM):
		oprintf("asm(");
		printexpr(stmt.left());
		if(stmt.mid() || stmt.right()) 
			oprintf(" : ");
		if(stmt.mid())
			printexpr(stmt.mid());
		if(stmt.right()) {
			oprintf(" : ");
			printexpr(stmt.right());
		}
		oprintf(");");
		break;
	case T(STMTLIST):
		printstmtlist(StmtList(stmt));
		break;
	case T(CTORINIT):
		printctorinit(StmtList(stmt.left()));
		printstmtlist(StmtList(stmt.mid()));
		break;
	default:
		printexpr(Expr(stmt));
		oprintf(";");
	}
}

void
CCOut::printstmti(Stmt stmt)
{
	if(!stmt) {
		rshift();
		onl();
		oprintf(";");
		lshift();
		return;
	}
	bool tab = (stmt.op() != T(STMTLIST));
	if(tab) {
		rshift();
		onl();
	} else
		oprintf(" ");
	printstmt(stmt);
	if(tab) 
		lshift();
}



void
CCOut::printexpr(Expr expr, bool paren = false)
{
	if(!expr) 
		return;
	if(paren)
		oprintf("(");
	bool space = true;
	char *fmt;
	type_t t;
	switch(expr.op()) {
	case T(STMTLIST):
		printdecllist(StmtList(expr));
		break;
	case T(EXPRLIST):
		printexprlist(ExprList(expr));
		break;
	case T(KW_FOR): 
		printexpr(expr.left());
		oprintf("; ");
		printexpr(expr.mid());
		oprintf("; ");
		printexpr(expr.right());
		break;
	case T(ARRAY):
		oprintf("{ ");
		printexprlist(ExprList(expr));
		oprintf(" }");
		break;
	case T(VAL_ID): {
		char buf[MAXIDLEN];
		oprintf("%s", scoped_string(expr.decl(), buf));
		break; }
	case T(TOKENLIST):
		regurgitate(expr.tlist());
		break;
	case T(LITERAL):
		printliteral(expr.lit().type, expr.lit().val);
		break;
	case T(QMARK):
		oprintf("(");
		printexpr(expr.left(), true);
		oprintf("?");
		printexpr(expr.mid(), true);
		oprintf(":");
		printexpr(expr.right(), true);
		oprintf(")");
		break;
	case T(OP_PTRTO): case T(OP_MPTRTO):
		t = ((PtrTo*)expr.left().rtype()->ptr())->rtype();
		goto printmember;
	case T(OP_DOT): case T(OP_MDOT):
		t = expr.left().rtype();
	    printmember:
		{
			Aggr *aggr = (Aggr*)t->ptr();
			Expr left = expr.left();
			CAction::Token op = expr.op();
			int p = tokenprec(op, 0);
			int pleft = tokenprec(left.op(), -1);
			printexpr(left, pleft < p || !p);
			const Scope savescope = _scope;
			_scope = aggr->scope();
			oprintf("%s", _clex.token_string((CLex::Token)op));
			printexpr(expr.right(), false);
			_scope = savescope;
		}
		break;
	case T(OP_NEW):
		oprintf("new ");
		if(expr.right()) {
			oprintf("(");
			printexpr(expr.right());
			oprintf(") ");
		}
		{
			char buf[MAXTYPELEN];
			buf[0] = '\0';
			type_string(expr.left().rtype(), buf);
			oprintf(strchr(buf, '(') ? "(%s)" : "%s", buf);
		}
		if(expr.mid()) {
			oprintf("(");
			printexpr(expr.mid());
			oprintf(")");
		}
		break;
	case T(OP_CAST): fmt = "(%s)"; goto printcast;
	case T(KW_CCAST): fmt = "const_cast<%s>"; goto printcast;
	case T(KW_RCAST): fmt = "reinterpret_cast<%s>"; goto printcast;
	case T(KW_DCAST): fmt = "dynamic_cast<%s>"; goto printcast;
	case T(KW_SCAST): fmt = "static_cast<%s>"; goto printcast;
	    printcast:
		{
			char buf[MAXTYPELEN];
			buf[0] = '\0';
			oprintf(fmt, type_string(expr.right().rtype(), buf));
			oprintf("(");
			printexpr(expr.left());
			oprintf(")");
		}
		break;
	case T(DECL): {
		Decl *d = expr.left().decl();
		define_sym(d, false);
		d->odeclared = true;
		d->odefined = true;
		break; }
	case T(ID):
		oprintf("%s", _strtab->string(expr.id()));
		break;
	default: {
		Expr left = expr.left();
		Expr right = expr.right();
		int p = tokenprec(expr.op(), 0);
		int pleft = left ? tokenprec(left.op(), -1) : 0;
		int pright = right ? tokenprec(right.op(), 1) : 0;
		printexpr(left, pleft < p || !p);
		csz *s = 0, *e = 0;
		switch(CAction::Token op = expr.op()) {
		case T(OP_INCP): s = "++"; space = false; break;
		case T(OP_DECP): s = "--"; space = false; break;
		case T(OP_REF): s = "&"; space = false; break;
		case T(OP_PTR): s = "*"; space = false; break;
		case T(OP_UMINUS): s = " -"; space = false; break;
		case T(OP_UPLUS): s = " +"; space = false; break;
		case T(OP_INDEX): s = "["; e = "]"; space = false; break;
		case T(OP_FUNC): break;
		case T(OP_ADD): case T(OP_SUB):
		case T(OP_MUL): case T(OP_DIV): case T(OP_MOD):
		case T(OP_AND): case T(OP_OR): case T(OP_XOR):
		case T(OP_NOT): case T(OP_LNOT):
		case T(OP_DOT): case T(OP_PTRTO):
		case T(OP_SCOPE): case T(OP_MDOT): case T(OP_MPTRTO):
		case T(OP_LSHIFT): case T(OP_RSHIFT):
		case T(OP_DEC): case T(OP_INC):
			space = false;
		default:
			s = _clex.token_string((CLex::Token)op);
		}
		if(s)
			oprintf(space ?  (_x > _indent ? " %s " : "%s ")
					: "%s", s);
		printexpr(right, pright <= p || !p);
		if(e)
			oprintf("%s", e);
		}
	}
	if(paren)
		oprintf(")");
}


static bool
is_type(Decl *decl)
{
	if(decl->storage == Decl::sc_typedef)
		return true;
	if(decl->dtype == Decl::dt_enum) 
		return true;
	if(Decl::dtflags[decl->dtype] & Decl::DTF_SCOPE)
		return true;
	return false; 
}

static bool
can_declare(Decl *decl)
{
	if(decl->dtype == Decl::dt_enum) 
		return false;
	if(decl->storage == Decl::sc_typedef) 
		return decl->tagged();
	if(decl->is_func())
		return true;
	if(decl->storage == Decl::sc_extern)
		return true;
	if(decl->scope.parent()) {
		return decl->storage == Decl::sc_static;
	} else {
		return decl->storage == Decl::sc_default;
	}
}

static bool has_dependencies(Decl *decl, Scope outof = 0);

static bool
has_dependencies(Expr expr)
{
	if(!expr)
		return false;
	switch(expr.op()) {
	case T(VAL_ID):
		return has_dependencies(expr.decl());
	case T(TOKENLIST):
		return false;	/* XXX */
	case T(LITERAL):
		return false;
	case T(CTORINIT):
	case T(ARRAY):
	case T(EXPRLIST):
	case T(STMTLIST):
		return false;	/* XXX */
	case T(TYPE):
		return false;	/* XXX */
	default: 
		if(has_dependencies(expr.left()))
			return true;
		if(has_dependencies(expr.mid()))
			return true;
		if(has_dependencies(expr.right()))
			return true;
		return false;
	}
}


static bool
has_dependencies(type_t type, Scope outof, bool needdef)
{
	if(!type)
		return false;
	if(DeclRef *dref = dcast_DeclRef(type)) {
		Decl *decl = dref->decl();
		if(decl->nooutput) {
			if(needdef)
				decl->oneeddef = true;
			else
				decl->oneeddecl = true;
			return false;
		}
		if(needdef) {
			if(!decl->odefined && !subscope(outof, decl->scope)) {
				decl->oneeddef = true;
				return true;
			}
			// if(decl->storage == Decl::sc_typedef)
			//	return has_dependencies(decl->ptype, outof,
			//				true);
		} else {
			if(!decl->odeclared && !subscope(outof, decl->scope)) {
				decl->oneeddecl = true;
				return true;
			}
		}
	} else if(Aggr *aggr = dcast_Aggr(type)) {
		if(Scope sc = aggr->scope()) {
			if(!outof)
				outof = sc;
			if(Decl *d = sc.get(ID_INHERIT)) {
				for(; d; d = d->link) {
					if(d->i.decl->nooutput)
						d->i.decl->oneeddef = true;
					else if(!d->i.decl->odefined)
						return true;
				}
			}
			Decl *pd = sc.decl();
			for(Decl *d = pd->a.first; d; d = d->next) {
				if(has_dependencies(d->ptype, outof,
						!can_declare(d)))
					return true;
			}
		}
	} else if(Array *array = dcast_Array(type)) {
		return has_dependencies(array->rtype(), outof, needdef);
	} else if(PtrTo *ptr = dcast_PtrTo(type)) {
		return has_dependencies(ptr->rtype(), outof, false);
	} else if(RefTo *ref = dcast_RefTo(type)) {
		return has_dependencies(ref->rtype(), outof, false);
	} else if(Func *func = dcast_Func(type)) {
		if(has_dependencies(func->rtype(), outof, needdef))
			return true;
		for(uint i=0; i<func->nparam(); i++) 
			if(has_dependencies(func->ptype(i),
						outof, needdef)) 
				return true;
	} else if(Method *meth = dcast_Method(type)) {
		return has_dependencies(meth->ftype(), outof, needdef);
	}
	return false;
}

static bool
has_dependencies(Decl *decl, Scope outof = 0)
{
	bool needdef = decl->storage != Decl::sc_typedef || decl->tagged();
	if(decl->nooutput) {
		if(needdef)
			decl->oneeddef = true;
		else
			decl->oneeddecl = true;
		return false;
	}
	bool wasdefined = decl->odefined;
	bool wasdeclared = decl->odeclared;
	if(wasdefined)
		return false;
	decl->odefined = decl->defined;
	decl->odeclared = true;
	bool rv = false;
	if(has_dependencies(decl->ptype, outof, needdef))
		rv = true;
	else if(decl->initialized && decl->storage != Decl::sc_constant) 
		rv = has_dependencies(decl->v.expr);
	decl->odefined = wasdefined;
	decl->odeclared = wasdeclared;
	return rv;
}

void
CCOut::print_storageclass(Decl *decl)
{
	switch(decl->storage) {
	case Decl::sc_auto:	oprintf("auto "); break;
	case Decl::sc_static:	oprintf("static "); break;
	case Decl::sc_extern:	oprintf("extern "); break;
	case Decl::sc_register:	oprintf("register "); break;
	case Decl::sc_typedef:	oprintf("typedef "); break;
	case Decl::sc_mutable:	oprintf("mutable "); break;
	default: break;
	}
	if(decl->is_inline)
		oprintf("inline "); 
	if(decl->is_explicit)
		oprintf("explicit "); 
	if(decl->is_virtual)
		oprintf("virtual "); 
	if(decl->is_friend)
		oprintf("friend "); 
}

void
CCOut::regurgitate(TokenList *t)
{
	assert(t);

	char c[2];
	int plev = 0;
	CAction::Item item;
	CLex::Token tok, prevtok = (CLex::Token)T(NONE);
	bool first = true;
	while(t->next(&item)) {
		if(first && item.token == T(COLON)) {
			rshift();
			onltab(_indent-2); oprintf(": ");
			lshift();
			continue;
		}
		first = false;
		tok = (CLex::Token)item.token;
		switch(prevtok) {
		case T(RBRACE):
			if((tok != (CLex::Token)T(EOS))) {
				if(tok == (CLex::Token)T(KW_ELSE))
					oprintf(" ");
				else
					goto newline;
			}
			break;
		case T(LBRACE):
			rshift();
			goto newline;
			break;
		case T(EOS):
		newline:
			if(plev > 0)
				oprintf(" ");
			else if(tok != (CLex::Token)T(RBRACE))
				onl();
			break;
		default:
			oprintf("%s", _clex.token_spacing(prevtok, tok));
		}
		switch(item.token) {
		case T(NUM):
			oprintf(item.c.is_signed ? "%lld" : "%lluU", item.val);
			for(int i=0; i<item.c.is_long; i++)
				oprintf("L");
			break;
		case T(BOOL):
			oprintf("%s", _clex.token_string(tok, (bool)item.val));
			break;
		case T(CHAR): 
			c[0] = item.val;
			c[1] = '\0';
			oprintf("%s", _clex.token_string(tok, c, 1));
			break;
		case T(STR):
		case T(ID):
			oprintf("%s", _clex.token_string(tok,
					_strtab->string(item.id)));
			break;
		case T(EOS):
			oprintf(";");
			break;
		case T(LBRACE):
			if(_indent == 0)
				onl();
			oprintf("{");
			break;
		case T(RBRACE):
			lshift();
			if(prevtok == (CLex::Token)T(LBRACE))
				oprintf("}");
			else {
				onl();
				oprintf("}");
			}
			break;
		case T(LPAREN):
			plev++;
			goto dflt;
		case T(RPAREN):
			plev--;
			goto dflt;
		default:
		dflt:
			oprintf("%s", _clex.token_string(tok));
		}
		prevtok = tok;
	}
}

void
CCOut::print_access(Decl *decl)
{
	if(decl->access != _access) {
		onltab(_indent-_tabwid+1);
		oprintf("%s:", Decl::acname[decl->access]);
		onl();
		_access = decl->access;
	}
}

void
CCOut::define_aggr(Decl *decl)
{
	char buf[MAXIDLEN];
	Aggr *aggr = (Aggr*)decl->ptype->ptr();
	Scope scope = aggr->scope();
	if(!scope)
		return;
	Id aid = aggr->name();
	if(aid && aid != decl->id)
		oprintf(" %s", _strtab->string(aid));
	else {
		Scope scope = aggr->scope();
		if(Decl *d = scope.get(ID_INHERIT)) {
			oprintf(" : ");
			while(d) {
				Decl *bd = d->i.decl;
				if(d->access != (decl->dtype == TDecl::dt_class ? 
						TDecl::ac_private : TDecl::ac_public))
					oprintf("%s ", Decl::acname[d->access]);
				oprintf("%s", scoped_string(
					bd, buf, false));
				if((d = d->link))
					oprintf(", ");
			}
		}
		if(scope_empty(scope))
			oprintf(" {}");
		else {
			oprintf(" {");
			rshift();
			print_decls(scope, decl->dtype == Decl::dt_class
				? Decl::ac_private : Decl::ac_public); 
			lshift();	
			onl();
			oprintf("}");
		}
	}
}

void
CCOut::define_enum(Decl *decl)
{
	oprintf(" {");
	rshift();
	for(Decl *d = decl->a.first; d; d = d->next) {
		if(DeclRef *dref = dcast_DeclRef(d->ptype)) {
			Decl *d2 = dref->decl();
			if(d2 == decl) {
				onl();
				oprintf("%s = %lld,", 
					_strtab->string(d->id),
					(int64)d->c.val);
				d->odeclared = true;	
				d->odefined = true;
			}
		}
	}
	lshift();
	onl();
	oprintf("}");
}

void
CCOut::define_sym(Decl *decl, bool semi)
{
	char buf[MAXTYPELEN+MAXIDLEN];

	_curdecl = decl;
	
	if(decl->anon) 
		strcpy(buf, TDecl::dtname[decl->dtype]);
	else
		strcpy(buf, scoped_string(decl, buf, true));
	const Scope savescope = _scope;
	_scope = decl->scope;
	if(decl->is_func()) {
		if(decl->storage != TDecl::sc_typedef
		 && decl->storage != TDecl::sc_constant
		 && _indent == 0)
			strpcat(buf, "\n");
	}
	if(decl->ptype->is_type(Type_Aggr)) {
		if(_indent == 0)
			onl(2);
		oprintf("%s", buf);
		define_aggr(decl);
	} else if(decl->dtype == Decl::dt_enum) {
		oprintf("%s", buf);
		define_enum(decl);
	} else {
		if(decl->scope == savescope)
			print_storageclass(decl);
		oprintf("%s", type_string(decl->ptype, buf));
	}
	if(decl->initialized) {
		if(decl->is_func() && !decl->is_purevirtual()) {
			Expr e = decl->v.expr;
			if(e.op() == T(STMTLIST) && StmtList(e).empty()) {
				oprintf(" {}");
				onl();
				_scope = savescope;
				return;
			}
			onl();
			printstmt(decl->v.expr);
		} else {
			if(decl->storage == TDecl::sc_constant)
				oprintf(" = %lld", decl->c.val);
			else {
				if(Expr(decl->v.expr).op() == T(EXPRLIST)) {
					oprintf("(");
					printexpr(decl->v.expr);
					oprintf(")");
				} else {
					oprintf(" = ");
					printexpr(decl->v.expr);
				}
			}
			if(semi)
				oprintf(";");
		}
	} else if(semi)
		oprintf(";");
	_scope = savescope;
}


void
CCOut::declare_sym(Decl *decl)
{
	char buf[MAXTYPELEN+MAXIDLEN];

	_curdecl = decl;

	if(decl->id == ID_ANON) {
		if(DeclRef *dref = dcast_DeclRef(decl->ptype)) 
			define_sym(dref->decl());
		else
			INTERNAL_ERROR;
		return;
	}
	csz *ss = _strtab->string(decl->id);
	while(*ss == ' ')
		++ss;
	if(Decl::dtflags[decl->dtype] & Decl::DTF_SCOPE) {
		strcpy(buf, ss);
		oprintf("%s %s;", Decl::dtname[decl->dtype], buf);
	} else {
		print_storageclass(decl);
		strcpy(buf, ss);
		oprintf("%s;", type_string(decl->ptype, buf));
	}
	onl();
}


void
CCOut::print_types(const Scope sc)
{
	int nfail, ndec, ndef;
	Decl *pd = sc.decl();
	do {
	    nfail = ndec = ndef = 0;
	    for(Decl *d = pd->a.first; d; d = d->next) {
		if(d->nooutput)
			continue;
		if(d->dtype == Decl::dt_dtype
			  	|| d->dtype == Decl::dt_dclass) {
			if(!d->odefined) {
				d->odefined = true;
				d->odeclared = true;
			}
			continue;
		}
		if(!d->odefined && is_type(d)) {
		    if(has_dependencies(d)) {
		        if(!d->odeclared && d->oneeddecl
					&& can_declare(d)) {
				onl();
				print_access(d);
				if(!d->anon)
					declare_sym(d);
			    	d->odeclared = true;
			    	ndec++;
			}
			nfail++;
		    } else {
			onl();
			print_access(d);
			if(!d->anon)
				define_sym(d);
			d->odefined = true;
			ndef++;
			d->odeclared = true;
			ndec++;
		    } 
		}
	    }
	    if(nfail > 0 && ndec+ndef == 0) {
		    onl();
		    oprintf("/*** type dependency ordering failed ***/");
		    return;
	    }
	} while(nfail);
	onl();
}

void
CCOut::print_fndecls(const Scope sc, bool exp, bool stat)
{
	Decl *pd = sc.decl();
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(d->nooutput)
			continue;
		if(!d->odeclared && d->is_func()) {
			if(d->initialized && !exp)
				continue;
			if(d->storage == Decl::sc_static && !stat)
				continue;
			onl();
			print_access(d);
			has_dependencies(d);
			if(d->initialized && 
			    ( (Expr(d->v.expr).op() == T(STMTLIST)
				&& StmtList(d->v.expr).empty()
				&& d->is_inline)
			    || d->is_purevirtual())) { 
				define_sym(d);
				d->odefined = true;
			} else
				declare_sym(d);
			d->odeclared = true;
		}
	}
	onl();
}

void
CCOut::print_vardecls(const Scope sc, bool exp)
{
	Decl *pd = sc.decl();
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(d->nooutput)
			continue;
		if(!d->odeclared && !is_type(d) && !d->is_func()) {
			onl();
			if(!_scope.parent()) {
				if(d->storage == Decl::sc_default && exp)
					oprintf("extern ");
				else if(d->storage != Decl::sc_extern)
					continue;
			}
			print_access(d);
			has_dependencies(d);
			if(d->storage == Decl::sc_constant) {
				define_sym(d);
				d->odefined = true;
			} else
				declare_sym(d);
			d->odeclared = true;
		}
	}
	onl();
}


void
CCOut::print_decls(const Scope sc, TDecl::Access acc)
{
	TDecl::Access saveacc = _access;
	const Scope savescope = _scope;
	_access = acc;
	_scope = sc;
	if(!_scope.parent()) {
		onl(2); oprintf("// types:"); 
		print_types(sc);
		onl(2); oprintf("// imports:");
		print_fndecls(sc, false, false);
		print_vardecls(sc, false);
		onl(2); oprintf("// exports:");
		print_fndecls(sc, true, false);
		print_vardecls(sc, true);
		onl(2); oprintf("// local:"); 
		print_fndecls(sc, true, true);
		onl(2);
	} else {
		print_types(sc);
		print_vardecls(sc, true);
		print_fndecls(sc, true, true);
	}
	_access = saveacc;
	_scope = savescope;
	onl();
}



void
CCOut::print_defs(const Scope sc)
{
	int nfail, ndec, ndef;

	Decl *pd = sc.decl();

	//TDecl::Access saveacc = _access;
	//const Scope savescope = _scope;
	//_access = TDecl::ac_public;
	//_scope = sc;

	do {
		nfail = ndec = ndef = 0;
		for(Decl *d = pd->a.first; d; d = d->next) {
			if(d->nooutput || !d->defined)
				continue;
			if(!d->odefined) {
			    if(has_dependencies(d)) {
				if(!d->odeclared && d->oneeddecl) {
					onl();
					print_access(d);
					declare_sym(d);
					d->odeclared = true;
					ndec++;
				}
				printf("FAIL on: "); declare_sym(d);
					
				nfail++;
			    } else {
				if(!d->is_func()) {
					onl();
					define_sym(d);
					d->odefined = true;
					ndef++;
					d->odeclared = true;
					ndec++;
				}
			    }
			}
		}
		if(nfail > 0 && ndec+ndef == 0) {
			onl();
		    	oprintf("/*** definition dependency"
				 	" ordering failed ***/");
			onl();
			break;
		}
	} while(nfail);
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(Aggr *aggr = dcast_Aggr(d->ptype)) {
			Scope scope = aggr->scope();
			if(scope && !d->nooutput)
				print_defs(scope);
		}
	}    
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(d->nooutput || !d->defined)
			continue;
		if(!d->odefined) {
			if(d->is_func() && !d->initialized)
				continue;
			onl(2);
			define_sym(d);
			d->odeclared = true;
			d->odefined = true;
		}
	}

	//_access = saveacc;
	//_scope = savescope;
	onl();
}


void
CCOut::print_reqs(const Scope sc)
{
	onl(2);
	oprintf("// external declaration requirements:");
	onl();

	Decl *pd = sc.decl();
	for(Decl *d = pd->a.first; d; d = d->next) {
		if(!d->nooutput)
			continue;
		if(!d->oneeddecl || d->oneeddef)
			continue;
		oprintf("// ");
		declare_sym(d);
		onl();
	}

	onl(2);
	oprintf("// external definition requirements:");
	onl();

	for(Decl *d = pd->a.first; d; d = d->next) {
		if(!d->nooutput)
			continue;
		if(!d->oneeddef)
			continue;
		oprintf("// ");
		declare_sym(d);
		onl();
	}
}


CCOut::CCOut(ErrorReport &err, const Scope scope, TDecl::Access access)
	: _err(err), _clex(_buf, sizeof _buf)
{
	_scope = scope;
	_access = access;
	_strtab = scope.strtab();
	_x = 0;
	_nl = 1;
	_tabwid = 4;
	_obuf = 0;
	_fullscope = false;
	_debugtypes = false;
}

