/* worms.c
 *   simple worms program for VT100's
 */

int sprintf(char *, const char *, ...);
int write(int, void *, int);
int strlen(const char *);
int atoi(const char *);

typedef unsigned long ulong;

#ifdef CAN_INIT_ARRAYS
int sx[8] = {0,1,1,1,0,-1,-1,-1};
int sy[8] = {-1,-1,0,1,1,1,0,-1};
char wormchar[8] = {'O','*','#','$','%','0','@','~'};
#endif

ulong rnd(ulong n)
{
	static ulong seed;
	seed = (seed * 1656379747) + 2928734237;
	return((seed/17737) % n);
}


void worms(int wid,int hgt, int n, int len)
{
#ifndef CAN_INIT_ARRAYS
static int sx[8] = {0,1,1,1,0,-1,-1,-1};
static int sy[8] = {-1,-1,0,1,1,1,0,-1};
static char wormchar[8] = {'O','*','#','$','%','0','@','~'};
#endif
int wx[8][50];
int wy[8][50];
int dir[4];
int i;
int p,last;
char buf[400];
char *bp;
	for(i=0; i<n; i++) {
		for(p=0; p<len; p++) {
			wx[i][p] = 0;
			wy[i][p] = 0;	
		}	
		wx[i][0] = rnd(wid);
		wy[i][0] = rnd(hgt);
		dir[i] = rnd(8);
	}
	last = 0;
	p = 1;
	while(1) {
		buf[0] = '\0';
		bp = buf;
		for(i=0; i<n; i++) {
			while(*bp)
				bp++;
			sprintf(bp,"\033[%d;%dH ",wy[i][p]+1,wx[i][p]+1);
			dir[i] = (dir[i] + rnd(2) - rnd(2)) % 8;
			if(wx[i][last] < 1)
				dir[i] = 2;
			if(wx[i][last] > wid-2)
				dir[i] = 6;
			if(wy[i][last] < 1)
				dir[i] = 4;
			if(wy[i][last] > hgt-2)
				dir[i] = 0;
			wx[i][p] = wx[i][last] + sx[dir[i]];
			wy[i][p] = wy[i][last] + sy[dir[i]];
			while(*bp)
				bp++;
			sprintf(bp,"\033[%d;%dH%c",wy[i][p]+1,wx[i][p]+1,wormchar[i%8]);
		}	
		write(1, buf, strlen(buf));
		last = p;
		p = (p+1) % len;
	}
}


int main(int argc, char **argv)
{
char buf[10];
int n,l;
	sprintf(buf,"\033[2J");
	write(1, buf, strlen(buf));	
	n = 4;
	l = 15;
	if(argc > 1)
		n = atoi(argv[1]);
	if(argc > 2)
		l = atoi(argv[2]);
	worms(80,25,n,l);
}

