/*  $Id: printaction.h,v 1.1 1998/02/08 23:41:58 shaggy Exp $
 *      
 *      relative path: ./lib/cparse
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        C/C++ Parsing classes
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the Shag/OS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@mail.csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

//  $Log: printaction.h,v $
//  Revision 1.1  1998/02/08 23:41:58  shaggy
//  Initial revision
//


#include <defines>


#ifdef DEBUG
#define PRINT_ACTION(r,p1,p2,p3) \
	PrintAction _p_a_ (this, __FUNCTION__, r, p1, p2, p3)

class PrintAction {
	CAction *_caction;
	CAction::Item *_rval;
public:
	PrintAction(CAction *caction, csz *name,
		CAction::Item *rval,
		CAction::Item_ p1,
		CAction::Item_ p2,
		CAction::Item_ p3)
			: _caction(caction), _rval(rval)
		{ if(debugaction)
			_caction->mprint_action("", name, p1, p2, p3);
		}
	~PrintAction()
		{ if(debugaction)
			_caction->mprint_result("", *_rval);
		}
};

#else
#define PRINT_ACTION(r,p1,p2,p3) 	
#endif

